// produkt matrike in vektorja v ve nitkah
// vsaka nit izrauna del vektorja vectorY
#define HAVE_STRUCT_TIMESPEC

#include <stdio.h>
#include <pthread.h>

#define N 10
#define NTHREADS 2

double matrix[N][N];
double vectorX[N];
double vectorY[N];

void *mat_vec(void *arg)
{
	int i, j;
	int myRank = (int)arg;
	int start = (int)(N / (double)NTHREADS*myRank);
	int stop = (int)(N / (double)NTHREADS*(myRank + 1));

	for (i = start; i<stop; i++)
	{
		vectorY[i] = 0;
		for (j = 0; j<N; j++)
			vectorY[i] += matrix[i][j] * vectorX[j];
	}

	return NULL;
}

int main(void)
{
	int i, j;
	pthread_t t[NTHREADS];

	for(i=0; i<N; i++)
	{
		vectorX[i] = i/(double)N;
		for(j=0; j<N; j++)
			matrix[i][j] = i*j/(double)(N*N);
		vectorX[i] = 1;
		for(j=0; j<N; j++)
			matrix[i][j] = 1;
	}

	for( i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, mat_vec, (void *)i);

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	for(i=0; i<N; i++)
		printf("%lf\n", vectorY[i]);

	return 0;
}
